#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
#define ll long long

const int INF = int(1e9);

struct worker {
	int ind;
	int time;
	int floor;
};

int main() {
	int n, m;
	cin >> n >> m;
	vector<worker> v(n);
	vector<vector<worker>> fl(m);
	for (int i = 0; i < n; i++) {
		v[i].ind = i + 1;
		scanf("%d%d", &v[i].time, &v[i].floor);
		fl[v[i].floor - 1].push_back(v[i]);
	}
	int cnt = n;
	int t = 0;
	vector<int> res(n);
	vector<int> pt(m, 0);
	while (cnt != 0) {
		int mint = INF, minf, minind = INF;
		for (int i = 0; i < m; i++) {
			if (fl[i].size() && pt[i] != -1)
				if (fl[i][pt[i]].time < mint || (fl[i][pt[i]].time == mint && fl[i][pt[i]].ind < minind)) {
					mint = fl[i][pt[i]].time;
					minf = i;
					minind = fl[i][pt[i]].ind;
				}
		}
		t = max(t, mint) + minf;
		vector<int> down;
		for (int i = minf; i >= 1; i--) {
			if (fl[i].size() && pt[i] != -1)
				for (int j = pt[i]; fl[i][j].time <= t; j++, pt[i]++) {
					down.push_back(fl[i][j].ind - 1);
					if (j == fl[i].size() - 1) {
						pt[i] = -1;
						break;
					}
				}
			t++;
		}
		cnt -= down.size();
		for (int i = 0; i < down.size(); i++) {
			res[down[i]] = t;
		}
	}
	for (int i = 0; i < n; i++)
		printf("%d\n", res[i]);
	//system("pause");
	return 0;
}

/*
5 4
2 3
2 4
5 2
5 3
9 3
*/

/*
for (int i = m - 1; i >= 1; i--) {
for (int j = 0; j < fl[i].size(); j++)
cout << fl[i][j].ind << " ";
cout << endl;
}
cout << endl;
*/