#include <iostream>
#include <vector>
using namespace std;
#define ll long long

vector<int> depth;
vector<bool> used;
vector<vector<int>> v;

void dfs(int u) {
	used[u] = true;
	for (int i = 0; i < v[u].size(); i++) {
		if (!used[v[u][i]]) {
			depth[v[u][i]] = depth[u] + 1;
			dfs(v[u][i]);
		}
	}
}

int main() {
	int n, m;
	cin >> n >> m;
	depth.assign(n, 0);
	used.assign(n, false);
	v.assign(n, vector<int>());
	for (int i = 0; i < n - 1; i++) {
		int x;
		cin >> x;
		v[x - 1].push_back(i + 1);
	}
	dfs(0);
	int m1 = 0, m2 = 0;
	for (int i = 0; i < n; i++) {
		if (depth[i] > m1) {
			m2 = m1;
			m1 = depth[i];
		} else if (depth[i] > m2) {
			m2 = depth[i];
		}
	}
	cout << m1 + m2;
	//system("pause");
	return 0;
}